/******************************************************************************
 *
 * File:            PdfTools_Toolbox_PtxPdfForms.h
 *
 * Description:     Sub Header file for Toolbox SDK
 *
 * Author:          PDF Tools AG
 *
 * Copyright:       Copyright (C) 2024 - 2024 PDF Tools AG, Switzerland
 *                  All rights reserved.
 *
 * Notice:          By downloading and using this artifact, you accept PDF Tools AG's
 *                  [license agreement](https://www.pdf-tools.com/license-agreement/),
 *                  [privacy policy](https://www.pdf-tools.com/privacy-policy/),
 *                  and allow PDF Tools AG to track your usage data.
 *
 *****************************************************************************/

#ifndef PDFTOOLS_TOOLBOX_PTXPDFFORMS_H__
#define PDFTOOLS_TOOLBOX_PTXPDFFORMS_H__

#ifndef PDFTOOLS_TOOLBOX_CALL
#if defined(WIN32)
#define PDFTOOLS_TOOLBOX_CALL __stdcall
#else
#define PDFTOOLS_TOOLBOX_CALL
#endif
#endif

#include "PdfTools_Toolbox_Types.h"
#include "PdfTools_Toolbox_PtxSys.h"

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _UNICODE
#define PtxPdfForms_FieldNodeMap_Lookup PtxPdfForms_FieldNodeMap_LookupW
#define PtxPdfForms_FieldNodeMap_Get    PtxPdfForms_FieldNodeMap_GetW
#define PtxPdfForms_FieldNodeMap_GetKey PtxPdfForms_FieldNodeMap_GetKeyW
#define PtxPdfForms_FieldNodeMap_Set    PtxPdfForms_FieldNodeMap_SetW

#define PtxPdfForms_FieldNode_GetDisplayName PtxPdfForms_FieldNode_GetDisplayNameW
#define PtxPdfForms_FieldNode_SetDisplayName PtxPdfForms_FieldNode_SetDisplayNameW
#define PtxPdfForms_FieldNode_GetExportName  PtxPdfForms_FieldNode_GetExportNameW
#define PtxPdfForms_FieldNode_SetExportName  PtxPdfForms_FieldNode_SetExportNameW

#define PtxPdfForms_TextField_GetText PtxPdfForms_TextField_GetTextW
#define PtxPdfForms_TextField_SetText PtxPdfForms_TextField_SetTextW

#define PtxPdfForms_CheckBox_GetCheckedExportName PtxPdfForms_CheckBox_GetCheckedExportNameW

#define PtxPdfForms_RadioButton_GetExportName PtxPdfForms_RadioButton_GetExportNameW

#define PtxPdfForms_RadioButtonGroup_AddNewButton PtxPdfForms_RadioButtonGroup_AddNewButtonW

#define PtxPdfForms_ChoiceItem_GetDisplayName PtxPdfForms_ChoiceItem_GetDisplayNameW
#define PtxPdfForms_ChoiceItem_SetDisplayName PtxPdfForms_ChoiceItem_SetDisplayNameW
#define PtxPdfForms_ChoiceItem_GetExportName  PtxPdfForms_ChoiceItem_GetExportNameW
#define PtxPdfForms_ChoiceItem_SetExportName  PtxPdfForms_ChoiceItem_SetExportNameW

#define PtxPdfForms_ChoiceField_AddNewItem PtxPdfForms_ChoiceField_AddNewItemW

#define PtxPdfForms_ComboBox_GetEditableItemName PtxPdfForms_ComboBox_GetEditableItemNameW
#define PtxPdfForms_ComboBox_SetEditableItemName PtxPdfForms_ComboBox_SetEditableItemNameW

#define PtxPdfForms_SignedSignatureField_GetName PtxPdfForms_SignedSignatureField_GetNameW

#define PtxPdfForms_Signature_GetLocation PtxPdfForms_Signature_GetLocationW

#define PtxPdfForms_Signature_GetReason PtxPdfForms_Signature_GetReasonW

#define PtxPdfForms_Signature_GetContactInfo PtxPdfForms_Signature_GetContactInfoW

#else
#define PtxPdfForms_FieldNodeMap_Lookup PtxPdfForms_FieldNodeMap_LookupA
#define PtxPdfForms_FieldNodeMap_Get    PtxPdfForms_FieldNodeMap_GetA
#define PtxPdfForms_FieldNodeMap_GetKey PtxPdfForms_FieldNodeMap_GetKeyA
#define PtxPdfForms_FieldNodeMap_Set    PtxPdfForms_FieldNodeMap_SetA

#define PtxPdfForms_FieldNode_GetDisplayName PtxPdfForms_FieldNode_GetDisplayNameA
#define PtxPdfForms_FieldNode_SetDisplayName PtxPdfForms_FieldNode_SetDisplayNameA
#define PtxPdfForms_FieldNode_GetExportName  PtxPdfForms_FieldNode_GetExportNameA
#define PtxPdfForms_FieldNode_SetExportName  PtxPdfForms_FieldNode_SetExportNameA

#define PtxPdfForms_TextField_GetText PtxPdfForms_TextField_GetTextA
#define PtxPdfForms_TextField_SetText PtxPdfForms_TextField_SetTextA

#define PtxPdfForms_CheckBox_GetCheckedExportName PtxPdfForms_CheckBox_GetCheckedExportNameA

#define PtxPdfForms_RadioButton_GetExportName PtxPdfForms_RadioButton_GetExportNameA

#define PtxPdfForms_RadioButtonGroup_AddNewButton PtxPdfForms_RadioButtonGroup_AddNewButtonA

#define PtxPdfForms_ChoiceItem_GetDisplayName PtxPdfForms_ChoiceItem_GetDisplayNameA
#define PtxPdfForms_ChoiceItem_SetDisplayName PtxPdfForms_ChoiceItem_SetDisplayNameA
#define PtxPdfForms_ChoiceItem_GetExportName  PtxPdfForms_ChoiceItem_GetExportNameA
#define PtxPdfForms_ChoiceItem_SetExportName  PtxPdfForms_ChoiceItem_SetExportNameA

#define PtxPdfForms_ChoiceField_AddNewItem PtxPdfForms_ChoiceField_AddNewItemA

#define PtxPdfForms_ComboBox_GetEditableItemName PtxPdfForms_ComboBox_GetEditableItemNameA
#define PtxPdfForms_ComboBox_SetEditableItemName PtxPdfForms_ComboBox_SetEditableItemNameA

#define PtxPdfForms_SignedSignatureField_GetName PtxPdfForms_SignedSignatureField_GetNameA

#define PtxPdfForms_Signature_GetLocation PtxPdfForms_Signature_GetLocationA

#define PtxPdfForms_Signature_GetReason PtxPdfForms_Signature_GetReasonA

#define PtxPdfForms_Signature_GetContactInfo PtxPdfForms_Signature_GetContactInfoA

#endif

/******************************************************************************
 * FieldNodeMap
 *****************************************************************************/
/**
 * @brief Access a form field by path
Lookup the form field node given by the identifier path.

* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] szIdentifierPath the identifier path in which sub forms must be delimited by full stops '.'


 * @return   the resulting form field node.

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the document has already been closed

 * - \ref ePtx_Error_NotFound if no form field with this identifier exists


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_FieldNode* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_LookupA(TPtxPdfForms_FieldNodeMap* pFieldNodeMap, const char* szIdentifierPath);
/**
 * @brief Access a form field by path
Lookup the form field node given by the identifier path.

* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] szIdentifierPath the identifier path in which sub forms must be delimited by full stops '.'


 * @return   the resulting form field node.

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the document has already been closed

 * - \ref ePtx_Error_NotFound if no form field with this identifier exists


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_FieldNode* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_LookupW(TPtxPdfForms_FieldNodeMap* pFieldNodeMap, const WCHAR* szIdentifierPath);
/**
 * @brief The number of key-value pairs in the map.
* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.


 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState

 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_GetCount(TPtxPdfForms_FieldNodeMap* pFieldNodeMap);
/**
 * @brief The number of key-value pairs in the map.
* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.


 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState

 * @deprecated Deprecated in Version 1.1.0.
 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_GetSize(TPtxPdfForms_FieldNodeMap* pFieldNodeMap);
/**
 * @brief Get the position of the first entry in the map.

The order of the entries is arbitrary and not significant.

If the returned position differs from \ref PtxPdfForms_FieldNodeMap_GetEnd,then the position can be used to retrieve the
map entry with \ref PtxPdfForms_FieldNodeMap_GetKey,  \ref PtxPdfForms_FieldNodeMap_GetValue.

Use \ref PtxPdfForms_FieldNodeMap_GetNext to get the position of the next entry.

* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.


 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_GetBegin(TPtxPdfForms_FieldNodeMap* pFieldNodeMap);
/**
 * @brief Get the end position of the map.

This position does not correspond to an actual entry in the map.

It must be used to determine whether the end of the map has been reached when using \ref
PtxPdfForms_FieldNodeMap_GetBegin and \ref PtxPdfForms_FieldNodeMap_GetNext.

* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.


 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_GetEnd(TPtxPdfForms_FieldNodeMap* pFieldNodeMap);
/**
 * @brief Get the position of the next entry in the map.

The order of the entries is arbitrary and not significant.

If the returned position differs from \ref PtxPdfForms_FieldNodeMap_GetEnd, then the position can be used to retrieve
the map entry with \ref PtxPdfForms_FieldNodeMap_GetKey and \ref PtxPdfForms_FieldNodeMap_GetValue.

* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] it

 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_GetNext(TPtxPdfForms_FieldNodeMap* pFieldNodeMap, int it);
/**
 * @brief Get the position of a key in the map.
If no error occurred, then the position can be used to get the corresponding value with \ref
PtxPdfForms_FieldNodeMap_GetValue.

* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] szKey

 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_NotFound
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_GetA(TPtxPdfForms_FieldNodeMap* pFieldNodeMap, const char* szKey);
/**
 * @brief Get the position of a key in the map.
If no error occurred, then the position can be used to get the corresponding value with \ref
PtxPdfForms_FieldNodeMap_GetValue.

* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] szKey

 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_NotFound
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_GetW(TPtxPdfForms_FieldNodeMap* pFieldNodeMap, const WCHAR* szKey);
/**
 * @brief Get the key of the entry given a position.
* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] it
* @param[out] pBuffer To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
   `0` if there is an error.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_GetKeyA(TPtxPdfForms_FieldNodeMap* pFieldNodeMap, int it, char* pBuffer, size_t nBufferSize);
/**
 * @brief Get the key of the entry given a position.
* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] it
* @param[out] pBuffer To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
   `0` if there is an error.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_GetKeyW(TPtxPdfForms_FieldNodeMap* pFieldNodeMap, int it, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief Get the value of the entry given a position.
* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] it

 * @return    `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_FieldNode* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_GetValue(TPtxPdfForms_FieldNodeMap* pFieldNodeMap, int it);
/**
 * @brief Set the value of an entry for a given key.
This operation invalidates all positions previously returned by‹pre›_‹map›_GetBegin, \ref
PtxPdfForms_FieldNodeMap_GetEnd, \ref PtxPdfForms_FieldNodeMap_GetNext, and \ref PtxPdfForms_FieldNodeMap_Get.

* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] szKey
* @param[in,out] pValue

 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_FieldNodeMap_SetA(
    TPtxPdfForms_FieldNodeMap* pFieldNodeMap, const char* szKey, TPtxPdfForms_FieldNode* pValue);
/**
 * @brief Set the value of an entry for a given key.
This operation invalidates all positions previously returned by‹pre›_‹map›_GetBegin, \ref
PtxPdfForms_FieldNodeMap_GetEnd, \ref PtxPdfForms_FieldNodeMap_GetNext, and \ref PtxPdfForms_FieldNodeMap_Get.

* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] szKey
* @param[in,out] pValue

 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_FieldNodeMap_SetW(
    TPtxPdfForms_FieldNodeMap* pFieldNodeMap, const WCHAR* szKey, TPtxPdfForms_FieldNode* pValue);
/**
 * @brief Set the value of the entry at a position in the map.
* @param[in,out] pFieldNodeMap Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNodeMap.

* @param[in] it
* @param[in,out] pValue

 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNodeMap_SetValue(TPtxPdfForms_FieldNodeMap* pFieldNodeMap, int it, TPtxPdfForms_FieldNode* pValue);

/******************************************************************************
 * WidgetList
 *****************************************************************************/
/**
 * @brief Get the number of elements in the list.
* @param[in,out] pWidgetList Acts as a handle to the native object of type \ref TPtxPdfForms_WidgetList.


 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState

 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL PtxPdfForms_WidgetList_GetCount(TPtxPdfForms_WidgetList* pWidgetList);
/**
 * @brief Returns the element at the specified position in the given list.
* @param[in,out] pWidgetList Acts as a handle to the native object of type \ref TPtxPdfForms_WidgetList.

* @param[in] iIndex

 * @return    `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_Widget* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_WidgetList_Get(TPtxPdfForms_WidgetList* pWidgetList, int iIndex);
/**
 * @brief Add an element to the end of the list.
* @param[in,out] pWidgetList Acts as a handle to the native object of type \ref TPtxPdfForms_WidgetList.

* @param[in,out] pWidget

 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_WidgetList_Add(TPtxPdfForms_WidgetList* pWidgetList,
                                                                              TPtxPdfForms_Widget*     pWidget);

/******************************************************************************
 * SignatureFieldList
 *****************************************************************************/
/**
 * @brief Get the number of elements in the list.
* @param[in,out] pSignatureFieldList Acts as a handle to the native object of type \ref TPtxPdfForms_SignatureFieldList.


 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState

 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_SignatureFieldList_GetCount(TPtxPdfForms_SignatureFieldList* pSignatureFieldList);
/**
 * @brief Returns the element at the specified position in the given list.
* @param[in,out] pSignatureFieldList Acts as a handle to the native object of type \ref TPtxPdfForms_SignatureFieldList.

* @param[in] iIndex

 * @return    `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_SignatureField* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_SignatureFieldList_Get(TPtxPdfForms_SignatureFieldList* pSignatureFieldList, int iIndex);

/******************************************************************************
 * Widget
 *****************************************************************************/
/**
 * @brief The location on the page
* @param[in,out] pWidget Acts as a handle to the native object of type \ref TPtxPdfForms_Widget.

* @param[out] pBoundingBox Retrieved value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_Corrupt if the PDF is corrupt


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Widget_GetBoundingBox(TPtxPdfForms_Widget* pWidget, TPtxGeomReal_Rectangle* pBoundingBox);
/**
 * @brief The widget's visibility
If \ref "TRUE" then the widget is present, but is invisible and not available for user interaction.
Depending on the \ref PtxPdfForms_Widget_GetNoPrint "" property it will, however, still be visible when printing.

* @param[in,out] pWidget Acts as a handle to the native object of type \ref TPtxPdfForms_Widget.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_Widget_GetHidden(TPtxPdfForms_Widget* pWidget);
/**
 * @brief The widget's visibility when printing
If \ref "TRUE" then the widget is not present in a print output of the document.

* @param[in,out] pWidget Acts as a handle to the native object of type \ref TPtxPdfForms_Widget.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_Widget_GetNoPrint(TPtxPdfForms_Widget* pWidget);

/******************************************************************************
 * FieldNode
 *****************************************************************************/
/**
 * @brief Copy a form field node
Copy a form field node object from an input document to the given <b>pTargetDocument</b>.
The returned object is associated with the given target document but not yet part of it.

* @param[in,out] pTargetDocument the output document with which the returned object is associated

* @param[in,out] pFieldNode a form field of a different document


 * @return   the copied form field, associated with the current document

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IO Error reading from the source document or writing to the target document

 * - \ref ePtx_Error_Conformance The conformance level of the source document is not compatible
with the conformance level of the target document.

 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument has already been closed

 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument is read-only

 * - \ref ePtx_Error_IllegalArgument the <b>pFieldNode</b> object is not associated with an input document

 * - \ref ePtx_Error_IllegalArgument the target document contains form fields that have been implicitly copied by a call
to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetFormFields "" was set to \ref ePtxPdfForms_FormFieldCopyStrategy_Copy ""

 * - \ref ePtx_Error_IllegalArgument the target document contains unsigned signatures that have been implicitly copied
by a call to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetUnsignedSignatures "" was set to \ref ePtxPdf_CopyStrategy_Copy "".

 * - \ref ePtx_Error_IllegalArgument the document associated with the <b>pFieldNode</b> object has been closed


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_FieldNode* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNode_Copy(TPtxPdf_Document* pTargetDocument, TPtxPdfForms_FieldNode* pFieldNode);

/**
 * @brief User interface name
The display name is not directly visible, but a PDF viewer can display this name, e.g., in a tool tip.

* @param[in,out] pFieldNode Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNode.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNode_GetDisplayNameA(TPtxPdfForms_FieldNode* pFieldNode, char* pBuffer, size_t nBufferSize);
/**
 * @brief User interface name
The display name is not directly visible, but a PDF viewer can display this name, e.g., in a tool tip.

* @param[in,out] pFieldNode Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNode.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNode_GetDisplayNameW(TPtxPdfForms_FieldNode* pFieldNode, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief User interface name
The display name is not directly visible, but a PDF viewer can display this name, e.g., in a tool tip.

* @param[in,out] pFieldNode Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNode.

* @param[in] szDisplayName Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNode_SetDisplayNameA(TPtxPdfForms_FieldNode* pFieldNode, const char* szDisplayName);
/**
 * @brief User interface name
The display name is not directly visible, but a PDF viewer can display this name, e.g., in a tool tip.

* @param[in,out] pFieldNode Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNode.

* @param[in] szDisplayName Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNode_SetDisplayNameW(TPtxPdfForms_FieldNode* pFieldNode, const WCHAR* szDisplayName);
/**
 * @brief The name used when exporting
* @param[in,out] pFieldNode Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNode.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNode_GetExportNameA(TPtxPdfForms_FieldNode* pFieldNode, char* pBuffer, size_t nBufferSize);
/**
 * @brief The name used when exporting
* @param[in,out] pFieldNode Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNode.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNode_GetExportNameW(TPtxPdfForms_FieldNode* pFieldNode, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief The name used when exporting
* @param[in,out] pFieldNode Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNode.

* @param[in] szExportName Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNode_SetExportNameA(TPtxPdfForms_FieldNode* pFieldNode, const char* szExportName);
/**
 * @brief The name used when exporting
* @param[in,out] pFieldNode Acts as a handle to the native object of type \ref TPtxPdfForms_FieldNode.

* @param[in] szExportName Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNode_SetExportNameW(TPtxPdfForms_FieldNode* pFieldNode, const WCHAR* szExportName);

/**
 * @brief Get actual derived type of base type \ref TPtxPdfForms_FieldNode.
 *
 * This function is invoked prior to downcasting to ascertain the derived object type.
 *
 * @param[in,out] pFieldNode Acts as a handle to a native object.
 *
 * @return The item of the enumeration \ref TPtxPdfForms_FieldNodeType that refers to the actual derived type. `0` in
 * case of an error.
 *
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 *       Get the error message with \ref Ptx_GetLastErrorMessage.
 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_FieldNodeType PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_FieldNode_GetType(TPtxPdfForms_FieldNode* pFieldNode);
/******************************************************************************
 * SubForm
 *****************************************************************************/
/**
 * @brief Create a sub form
The returned sub form object is not yet used, but it is associated with the given target document.

* @param[in,out] pTargetDocument the output document with which the returned object is associated


 * @return   the newly created sub form

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument has already been closed

 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument is read-only

 * - \ref ePtx_Error_IllegalArgument the target document contains form fields that have been implicitly copied by a call
to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetFormFields "" was set to \ref ePtxPdfForms_FormFieldCopyStrategy_Copy ""

 * - \ref ePtx_Error_IllegalArgument the target document contains unsigned signatures that have been implicitly copied
by a call to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetUnsignedSignatures "" was set to \ref ePtxPdf_CopyStrategy_Copy "".


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_SubForm* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_SubForm_Create(TPtxPdf_Document* pTargetDocument);

/**
 * @brief The child form fields
Adding to this list results in an error:
  - <b>IllegalState</b> if the list has already been closed
  - <b>UnsupportedOperation</b> if the document is read-only
  - <b>IllegalArgument</b>
    - if the given form field node is `NULL`
    - if the given form field node has already been closed
    - if the given form field node does not belong to the same document as the list
    - if the given form field node has already been added to a form field node list
    - if the given form field node's identifier equals an identifier of one of the form field nodes in this list
This list does not support removing or setting elements or clearing.

* @param[in,out] pSubForm Acts as a handle to the native object of type \ref TPtxPdfForms_SubForm.


 * @return   Retrieved value.

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_FieldNodeMap* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_SubForm_GetChildren(TPtxPdfForms_SubForm* pSubForm);

/******************************************************************************
 * Field
 *****************************************************************************/
/**
 * @brief Create a new widget and add to the form field
This method creates a widget for the form field.
The widget is automatically added to the field's widgets, but not to any page.
This method does not work for radio button form fields;
Use \ref PtxPdfForms_RadioButton_AddNewWidget "".

* @param[in,out] pField Acts as a handle to the native object of type \ref TPtxPdfForms_Field.

* @param[in] pBoundingBox The widget's target rectangle on the page


 * @return   the newly created form field widget

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the document has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_UnsupportedOperation if the form field is of type \ref TPtxPdfForms_RadioButtonGroup ""


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_Widget* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Field_AddNewWidget(TPtxPdfForms_Field* pField, const TPtxGeomReal_Rectangle* pBoundingBox);

/**
 * @brief This form field's widget annotations
* @param[in,out] pField Acts as a handle to the native object of type \ref TPtxPdfForms_Field.


 * @return   Retrieved value.

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_WidgetList* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Field_GetWidgets(TPtxPdfForms_Field* pField);
/**
 * @brief Flags this field as read-only
* @param[in,out] pField Acts as a handle to the native object of type \ref TPtxPdfForms_Field.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_Field_GetReadOnly(TPtxPdfForms_Field* pField);
/**
 * @brief Flags this field as read-only
* @param[in,out] pField Acts as a handle to the native object of type \ref TPtxPdfForms_Field.

* @param[in] bReadOnly Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_Field_SetReadOnly(TPtxPdfForms_Field* pField,
                                                                                 BOOL                bReadOnly);
/**
 * @brief Flags this field as mandatory
* @param[in,out] pField Acts as a handle to the native object of type \ref TPtxPdfForms_Field.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_Field_GetRequired(TPtxPdfForms_Field* pField);
/**
 * @brief Flags this field as mandatory
* @param[in,out] pField Acts as a handle to the native object of type \ref TPtxPdfForms_Field.

* @param[in] bRequired Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_Field_SetRequired(TPtxPdfForms_Field* pField,
                                                                                 BOOL                bRequired);
/**
 * @brief Tells whether this field is exported
* @param[in,out] pField Acts as a handle to the native object of type \ref TPtxPdfForms_Field.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_Field_GetDoNotExport(TPtxPdfForms_Field* pField);
/**
 * @brief Tells whether this field is exported
* @param[in,out] pField Acts as a handle to the native object of type \ref TPtxPdfForms_Field.

* @param[in] bDoNotExport Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_Field_SetDoNotExport(TPtxPdfForms_Field* pField,
                                                                                    BOOL                bDoNotExport);

/**
 * @brief Get actual derived type of base type \ref TPtxPdfForms_Field.
 *
 * This function is invoked prior to downcasting to ascertain the derived object type.
 *
 * @param[in,out] pField Acts as a handle to a native object.
 *
 * @return The item of the enumeration \ref TPtxPdfForms_FieldType that refers to the actual derived type. `0` in case
 * of an error.
 *
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 *       Get the error message with \ref Ptx_GetLastErrorMessage.
 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_FieldType PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Field_GetType(TPtxPdfForms_Field* pField);
/******************************************************************************
 * TextField
 *****************************************************************************/
/**
 * @brief This field's text
* @param[in,out] pTextField Acts as a handle to the native object of type \ref TPtxPdfForms_TextField.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState the form field is marked as read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_IllegalArgument the string length of the given value exceeds the text field's \ref
PtxPdfForms_GeneralTextField_GetMaxLength ""


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL PtxPdfForms_TextField_GetTextA(TPtxPdfForms_TextField* pTextField,
                                                                                    char* pBuffer, size_t nBufferSize);
/**
 * @brief This field's text
* @param[in,out] pTextField Acts as a handle to the native object of type \ref TPtxPdfForms_TextField.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState the form field is marked as read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_IllegalArgument the string length of the given value exceeds the text field's \ref
PtxPdfForms_GeneralTextField_GetMaxLength ""


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL PtxPdfForms_TextField_GetTextW(TPtxPdfForms_TextField* pTextField,
                                                                                    WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief This field's text
* @param[in,out] pTextField Acts as a handle to the native object of type \ref TPtxPdfForms_TextField.

* @param[in] szText Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState the form field is marked as read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_IllegalArgument the string length of the given value exceeds the text field's \ref
PtxPdfForms_GeneralTextField_GetMaxLength ""


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_TextField_SetTextA(TPtxPdfForms_TextField* pTextField,
                                                                                  const char*             szText);
/**
 * @brief This field's text
* @param[in,out] pTextField Acts as a handle to the native object of type \ref TPtxPdfForms_TextField.

* @param[in] szText Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState the form field is marked as read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_IllegalArgument the string length of the given value exceeds the text field's \ref
PtxPdfForms_GeneralTextField_GetMaxLength ""


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_TextField_SetTextW(TPtxPdfForms_TextField* pTextField,
                                                                                  const WCHAR*            szText);
/**
 * @brief The text alignment
* @param[in,out] pTextField Acts as a handle to the native object of type \ref TPtxPdfForms_TextField.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxGeom_HorizontalAlignment PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_TextField_GetAlignment(TPtxPdfForms_TextField* pTextField);
/**
 * @brief The text alignment
* @param[in,out] pTextField Acts as a handle to the native object of type \ref TPtxPdfForms_TextField.

* @param[in] iAlignment Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_TextField_SetAlignment(TPtxPdfForms_TextField* pTextField, TPtxGeom_HorizontalAlignment iAlignment);
/**
 * @brief The font size
If `NULL` then the font size is chosen automatically by the PDF viewer.

* @param[in,out] pTextField Acts as a handle to the native object of type \ref TPtxPdfForms_TextField.

* @param[out] pFontSize Retrieved value.


 * @return   \ref FALSE if either an error occurred or the `[out]` argument returns `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_IllegalArgument if the given value is smaller than <b>0.0</b>


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_TextField_GetFontSize(TPtxPdfForms_TextField* pTextField,
                                                                                     double*                 pFontSize);
/**
 * @brief The font size
If `NULL` then the font size is chosen automatically by the PDF viewer.

* @param[in,out] pTextField Acts as a handle to the native object of type \ref TPtxPdfForms_TextField.

* @param[in] pFontSize Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_IllegalArgument if the given value is smaller than <b>0.0</b>


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_TextField_SetFontSize(TPtxPdfForms_TextField* pTextField,
                                                                                     const double*           pFontSize);

/**
 * @brief Get actual derived type of base type \ref TPtxPdfForms_TextField.
 *
 * This function is invoked prior to downcasting to ascertain the derived object type.
 *
 * @param[in,out] pTextField Acts as a handle to a native object.
 *
 * @return The item of the enumeration \ref TPtxPdfForms_TextFieldType that refers to the actual derived type. `0` in
 * case of an error.
 *
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 *       Get the error message with \ref Ptx_GetLastErrorMessage.
 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_TextFieldType PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_TextField_GetType(TPtxPdfForms_TextField* pTextField);
/******************************************************************************
 * GeneralTextField
 *****************************************************************************/
/**
 * @brief Create a general text form field
The returned form field object is not yet used, but it is associated with the given target document.

* @param[in,out] pTargetDocument the output document with which the returned object is associated


 * @return   the newly created general text field

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument has already been closed

 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument is read-only

 * - \ref ePtx_Error_IllegalArgument the target document contains form fields that have been implicitly copied by a call
to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetFormFields "" was set to \ref ePtxPdfForms_FormFieldCopyStrategy_Copy ""

 * - \ref ePtx_Error_IllegalArgument the target document contains unsigned signatures that have been implicitly copied
by a call to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetUnsignedSignatures "" was set to \ref ePtxPdf_CopyStrategy_Copy "".


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_GeneralTextField* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_GeneralTextField_Create(TPtxPdf_Document* pTargetDocument);

/**
 * @brief The maximal text length
When setting this property to a non-null value, the length of this field's text is truncated.

* @param[in,out] pGeneralTextField Acts as a handle to the native object of type \ref TPtxPdfForms_GeneralTextField.

* @param[out] pMaxLength Retrieved value.


 * @return   \ref FALSE if either an error occurred or the `[out]` argument returns `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_IllegalArgument if the given value is not `NULL` and is smaller than <b>0</b>


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_GeneralTextField_GetMaxLength(TPtxPdfForms_GeneralTextField* pGeneralTextField, int* pMaxLength);
/**
 * @brief The maximal text length
When setting this property to a non-null value, the length of this field's text is truncated.

* @param[in,out] pGeneralTextField Acts as a handle to the native object of type \ref TPtxPdfForms_GeneralTextField.

* @param[in] pMaxLength Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_IllegalArgument if the given value is not `NULL` and is smaller than <b>0</b>


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_GeneralTextField_SetMaxLength(TPtxPdfForms_GeneralTextField* pGeneralTextField, const int* pMaxLength);
/**
 * @brief Flags this text field as multi-line
* @param[in,out] pGeneralTextField Acts as a handle to the native object of type \ref TPtxPdfForms_GeneralTextField.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_GeneralTextField_GetMultiline(TPtxPdfForms_GeneralTextField* pGeneralTextField);
/**
 * @brief Flags this text field as multi-line
* @param[in,out] pGeneralTextField Acts as a handle to the native object of type \ref TPtxPdfForms_GeneralTextField.

* @param[in] bMultiline Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_GeneralTextField_SetMultiline(TPtxPdfForms_GeneralTextField* pGeneralTextField, BOOL bMultiline);
/**
 * @brief Flags this text field as a password entry field
* @param[in,out] pGeneralTextField Acts as a handle to the native object of type \ref TPtxPdfForms_GeneralTextField.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_GeneralTextField_GetPassword(TPtxPdfForms_GeneralTextField* pGeneralTextField);
/**
 * @brief Flags this text field as a password entry field
* @param[in,out] pGeneralTextField Acts as a handle to the native object of type \ref TPtxPdfForms_GeneralTextField.

* @param[in] bPassword Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_GeneralTextField_SetPassword(TPtxPdfForms_GeneralTextField* pGeneralTextField, BOOL bPassword);
/**
 * @brief Flags this text field for prevention from spell checking
* @param[in,out] pGeneralTextField Acts as a handle to the native object of type \ref TPtxPdfForms_GeneralTextField.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_GeneralTextField_GetDoNotSpellCheck(TPtxPdfForms_GeneralTextField* pGeneralTextField);
/**
 * @brief Flags this text field for prevention from spell checking
* @param[in,out] pGeneralTextField Acts as a handle to the native object of type \ref TPtxPdfForms_GeneralTextField.

* @param[in] bDoNotSpellCheck Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_GeneralTextField_SetDoNotSpellCheck(
    TPtxPdfForms_GeneralTextField* pGeneralTextField, BOOL bDoNotSpellCheck);
/**
 * @brief Flags this text field non scrollable
* @param[in,out] pGeneralTextField Acts as a handle to the native object of type \ref TPtxPdfForms_GeneralTextField.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_GeneralTextField_GetDoNotScroll(TPtxPdfForms_GeneralTextField* pGeneralTextField);
/**
 * @brief Flags this text field non scrollable
* @param[in,out] pGeneralTextField Acts as a handle to the native object of type \ref TPtxPdfForms_GeneralTextField.

* @param[in] bDoNotScroll Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_GeneralTextField_SetDoNotScroll(TPtxPdfForms_GeneralTextField* pGeneralTextField, BOOL bDoNotScroll);

/******************************************************************************
 * CombTextField
 *****************************************************************************/
/**
 * @brief Create a comb text form field
The returned form field object is not yet used, but it is associated with the given target document.

* @param[in,out] pTargetDocument the output document with which the returned object is associated

* @param[in] iMaxLength the maximal character length for this field


 * @return   the newly created comb text field

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument has already been closed

 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument is read-only

 * - \ref ePtx_Error_IllegalArgument the target document contains form fields that have been implicitly copied by a call
to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetFormFields "" was set to \ref ePtxPdfForms_FormFieldCopyStrategy_Copy ""

 * - \ref ePtx_Error_IllegalArgument the target document contains unsigned signatures that have been implicitly copied
by a call to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetUnsignedSignatures "" was set to \ref ePtxPdf_CopyStrategy_Copy "".

 * - \ref ePtx_Error_IllegalArgument if <b>iMaxLength</b> is smaller than 0


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_CombTextField* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_CombTextField_Create(TPtxPdf_Document* pTargetDocument, int iMaxLength);

/**
 * @brief The maximal text length
When setting this property, the length of this field's text is truncated to the given value.

* @param[in,out] pCombTextField Acts as a handle to the native object of type \ref TPtxPdfForms_CombTextField.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_IllegalArgument if the given value is smaller than <b>0</b>


 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_CombTextField_GetMaxLength(TPtxPdfForms_CombTextField* pCombTextField);
/**
 * @brief The maximal text length
When setting this property, the length of this field's text is truncated to the given value.

* @param[in,out] pCombTextField Acts as a handle to the native object of type \ref TPtxPdfForms_CombTextField.

* @param[in] iMaxLength Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_IllegalArgument if the given value is smaller than <b>0</b>


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_CombTextField_SetMaxLength(TPtxPdfForms_CombTextField* pCombTextField, int iMaxLength);

/******************************************************************************
 * CheckBox
 *****************************************************************************/
/**
 * @brief Create a check box form field
The returned form field object is not yet used, but it is associated with the given target document.

* @param[in,out] pTargetDocument the output document with which the returned object is associated


 * @return   the newly created check box field

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument has already been closed

 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument is read-only

 * - \ref ePtx_Error_IllegalArgument the target document contains form fields that have been implicitly copied by a call
to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetFormFields "" was set to \ref ePtxPdfForms_FormFieldCopyStrategy_Copy ""

 * - \ref ePtx_Error_IllegalArgument the target document contains unsigned signatures that have been implicitly copied
by a call to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetUnsignedSignatures "" was set to \ref ePtxPdf_CopyStrategy_Copy "".


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_CheckBox* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_CheckBox_Create(TPtxPdf_Document* pTargetDocument);

/**
 * @brief The name of the checked ('on') state used when exporting
* @param[in,out] pCheckBox Acts as a handle to the native object of type \ref TPtxPdfForms_CheckBox.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_CheckBox_GetCheckedExportNameA(TPtxPdfForms_CheckBox* pCheckBox, char* pBuffer, size_t nBufferSize);
/**
 * @brief The name of the checked ('on') state used when exporting
* @param[in,out] pCheckBox Acts as a handle to the native object of type \ref TPtxPdfForms_CheckBox.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_CheckBox_GetCheckedExportNameW(TPtxPdfForms_CheckBox* pCheckBox, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief The state of the check box
* @param[in,out] pCheckBox Acts as a handle to the native object of type \ref TPtxPdfForms_CheckBox.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field is marked as read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_CheckBox_GetChecked(TPtxPdfForms_CheckBox* pCheckBox);
/**
 * @brief The state of the check box
* @param[in,out] pCheckBox Acts as a handle to the native object of type \ref TPtxPdfForms_CheckBox.

* @param[in] bChecked Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field is marked as read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_CheckBox_SetChecked(TPtxPdfForms_CheckBox* pCheckBox,
                                                                                   BOOL                   bChecked);

/******************************************************************************
 * RadioButton
 *****************************************************************************/
/**
 * @brief Create radio button widget
This method creates a widget for the radio button.
The widget is automatically added to the button's widgets and to the radio button form field's widgets, but not to any
page.

* @param[in,out] pRadioButton Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButton.

* @param[in] pBoundingBox The widget's target rectangle on the page


 * @return   the newly created form field widget

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the document has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_Widget* PDFTOOLS_TOOLBOX_CALL PtxPdfForms_RadioButton_AddNewWidget(
    TPtxPdfForms_RadioButton* pRadioButton, const TPtxGeomReal_Rectangle* pBoundingBox);

/**
 * @brief The button's name used when exporting
* @param[in,out] pRadioButton Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButton.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_RadioButton_GetExportNameA(TPtxPdfForms_RadioButton* pRadioButton, char* pBuffer, size_t nBufferSize);
/**
 * @brief The button's name used when exporting
* @param[in,out] pRadioButton Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButton.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_RadioButton_GetExportNameW(TPtxPdfForms_RadioButton* pRadioButton, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief The button's widget annotations
* @param[in,out] pRadioButton Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButton.


 * @return   Retrieved value.

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_WidgetList* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_RadioButton_GetWidgets(TPtxPdfForms_RadioButton* pRadioButton);

/******************************************************************************
 * RadioButtonList
 *****************************************************************************/
/**
 * @brief Get the number of elements in the list.
* @param[in,out] pRadioButtonList Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButtonList.


 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState

 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_RadioButtonList_GetCount(TPtxPdfForms_RadioButtonList* pRadioButtonList);
/**
 * @brief Returns the element at the specified position in the given list.
* @param[in,out] pRadioButtonList Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButtonList.

* @param[in] iIndex

 * @return    `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_RadioButton* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_RadioButtonList_Get(TPtxPdfForms_RadioButtonList* pRadioButtonList, int iIndex);

/******************************************************************************
 * RadioButtonGroup
 *****************************************************************************/
/**
 * @brief Create a radio button form field
The returned form field object is not yet used, but it is associated with the given target document.

* @param[in,out] pTargetDocument the output document with which the returned object is associated


 * @return   the newly created radio button field

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument has already been closed

 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument is read-only

 * - \ref ePtx_Error_IllegalArgument the target document contains form fields that have been implicitly copied by a call
to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetFormFields "" was set to \ref ePtxPdfForms_FormFieldCopyStrategy_Copy ""

 * - \ref ePtx_Error_IllegalArgument the target document contains unsigned signatures that have been implicitly copied
by a call to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetUnsignedSignatures "" was set to \ref ePtxPdf_CopyStrategy_Copy "".


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_RadioButtonGroup* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_RadioButtonGroup_Create(TPtxPdf_Document* pTargetDocument);
/**
 * @brief Create a radio button
The created radio button is automatically added to this radio button field's \ref
PtxPdfForms_RadioButtonGroup_GetButtons "".

* @param[in,out] pRadioButtonGroup Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButtonGroup.

* @param[in] szExportName the radio button's export name


 * @return   the newly created radio button

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the document has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_RadioButton* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_RadioButtonGroup_AddNewButtonA(TPtxPdfForms_RadioButtonGroup* pRadioButtonGroup, const char* szExportName);
/**
 * @brief Create a radio button
The created radio button is automatically added to this radio button field's \ref
PtxPdfForms_RadioButtonGroup_GetButtons "".

* @param[in,out] pRadioButtonGroup Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButtonGroup.

* @param[in] szExportName the radio button's export name


 * @return   the newly created radio button

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the document has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_RadioButton* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_RadioButtonGroup_AddNewButtonW(TPtxPdfForms_RadioButtonGroup* pRadioButtonGroup, const WCHAR* szExportName);

/**
 * @brief This field's buttons
* @param[in,out] pRadioButtonGroup Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButtonGroup.


 * @return   Retrieved value.

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_RadioButtonList* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_RadioButtonGroup_GetButtons(TPtxPdfForms_RadioButtonGroup* pRadioButtonGroup);
/**
 * @brief This field's selected button
if `NULL` is set, then no button is chosen.

* @param[in,out] pRadioButtonGroup Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButtonGroup.


 * @return   Retrieved value.

  `NULL` if either an error occurred or the returned object is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `NULL` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalArgument if the provided radio button object does not belong to the radio button field

 * - \ref ePtx_Error_IllegalState if the given \ref TPtxPdfForms_RadioButton "" object is `NULL` and the radio button
group does not support toggling to off

 * - \ref ePtx_Error_IllegalState if the form field is marked as read-only


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_RadioButton* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_RadioButtonGroup_GetChosenButton(TPtxPdfForms_RadioButtonGroup* pRadioButtonGroup);
/**
 * @brief This field's selected button
if `NULL` is set, then no button is chosen.

* @param[in,out] pRadioButtonGroup Acts as a handle to the native object of type \ref TPtxPdfForms_RadioButtonGroup.

* @param[in,out] pChosenButton Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalArgument if the provided radio button object does not belong to the radio button field

 * - \ref ePtx_Error_IllegalState if the given \ref TPtxPdfForms_RadioButton "" object is `NULL` and the radio button
group does not support toggling to off

 * - \ref ePtx_Error_IllegalState if the form field is marked as read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_RadioButtonGroup_SetChosenButton(
    TPtxPdfForms_RadioButtonGroup* pRadioButtonGroup, TPtxPdfForms_RadioButton* pChosenButton);

/******************************************************************************
 * ChoiceItem
 *****************************************************************************/
/**
 * @brief Displayed name
This is the name of the item as displayed in a PDF viewer.

* @param[in,out] pChoiceItem Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItem.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the owning choice field's document is read-only

 * - \ref ePtx_Error_IllegalState if the owning choice field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItem_GetDisplayNameA(TPtxPdfForms_ChoiceItem* pChoiceItem, char* pBuffer, size_t nBufferSize);
/**
 * @brief Displayed name
This is the name of the item as displayed in a PDF viewer.

* @param[in,out] pChoiceItem Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItem.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the owning choice field's document is read-only

 * - \ref ePtx_Error_IllegalState if the owning choice field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItem_GetDisplayNameW(TPtxPdfForms_ChoiceItem* pChoiceItem, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief Displayed name
This is the name of the item as displayed in a PDF viewer.

* @param[in,out] pChoiceItem Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItem.

* @param[in] szDisplayName Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the owning choice field's document is read-only

 * - \ref ePtx_Error_IllegalState if the owning choice field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItem_SetDisplayNameA(TPtxPdfForms_ChoiceItem* pChoiceItem, const char* szDisplayName);
/**
 * @brief Displayed name
This is the name of the item as displayed in a PDF viewer.

* @param[in,out] pChoiceItem Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItem.

* @param[in] szDisplayName Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the owning choice field's document is read-only

 * - \ref ePtx_Error_IllegalState if the owning choice field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItem_SetDisplayNameW(TPtxPdfForms_ChoiceItem* pChoiceItem, const WCHAR* szDisplayName);
/**
 * @brief Export name
This is the name of the item used when exporting.

* @param[in,out] pChoiceItem Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItem.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the owning choice field's document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItem_GetExportNameA(TPtxPdfForms_ChoiceItem* pChoiceItem, char* pBuffer, size_t nBufferSize);
/**
 * @brief Export name
This is the name of the item used when exporting.

* @param[in,out] pChoiceItem Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItem.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the owning choice field's document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItem_GetExportNameW(TPtxPdfForms_ChoiceItem* pChoiceItem, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief Export name
This is the name of the item used when exporting.

* @param[in,out] pChoiceItem Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItem.

* @param[in] szExportName Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the owning choice field's document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItem_SetExportNameA(TPtxPdfForms_ChoiceItem* pChoiceItem, const char* szExportName);
/**
 * @brief Export name
This is the name of the item used when exporting.

* @param[in,out] pChoiceItem Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItem.

* @param[in] szExportName Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the owning choice field's document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItem_SetExportNameW(TPtxPdfForms_ChoiceItem* pChoiceItem, const WCHAR* szExportName);

/******************************************************************************
 * ChoiceItemList
 *****************************************************************************/
/**
 * @brief Get the number of elements in the list.
* @param[in,out] pChoiceItemList Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItemList.


 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState

 */
PDFTOOLS_TOOLBOX_EXPORT int PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItemList_GetCount(TPtxPdfForms_ChoiceItemList* pChoiceItemList);
/**
 * @brief Returns the element at the specified position in the given list.
* @param[in,out] pChoiceItemList Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItemList.

* @param[in] iIndex

 * @return    `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_ChoiceItem* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItemList_Get(TPtxPdfForms_ChoiceItemList* pChoiceItemList, int iIndex);
/**
 * @brief Add an element to the end of the list.
* @param[in,out] pChoiceItemList Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItemList.

* @param[in,out] pChoiceItem

 * @return    May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItemList_Add(TPtxPdfForms_ChoiceItemList* pChoiceItemList, TPtxPdfForms_ChoiceItem* pChoiceItem);
/**
 * @brief Clear list.
* @param[in,out] pChoiceItemList Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItemList.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState

 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItemList_Clear(TPtxPdfForms_ChoiceItemList* pChoiceItemList);
/**
 * @brief Remove certain element from list.
* @param[in,out] pChoiceItemList Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceItemList.

* @param[in] iIndex

 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState
 * - \ref ePtx_Error_IllegalArgument
 * - \ref ePtx_Error_UnsupportedOperation

 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceItemList_Remove(TPtxPdfForms_ChoiceItemList* pChoiceItemList, int iIndex);

/******************************************************************************
 * ChoiceField
 *****************************************************************************/
/**
Creates a new choice item.
The item is automatically added to the choice field's \ref PtxPdfForms_ChoiceField_GetItems "".

* @param[in,out] pChoiceField Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceField.

* @param[in] szDisplayName this item's display name


 * @return   the newly created choice item

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_UnsupportedOperation the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_ChoiceItem* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceField_AddNewItemA(TPtxPdfForms_ChoiceField* pChoiceField, const char* szDisplayName);
/**
Creates a new choice item.
The item is automatically added to the choice field's \ref PtxPdfForms_ChoiceField_GetItems "".

* @param[in,out] pChoiceField Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceField.

* @param[in] szDisplayName this item's display name


 * @return   the newly created choice item

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_IllegalState if the form field has widgets

 * - \ref ePtx_Error_UnsupportedOperation the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_ChoiceItem* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceField_AddNewItemW(TPtxPdfForms_ChoiceField* pChoiceField, const WCHAR* szDisplayName);

/**
 * @brief The list of choice items
Adding or removing items or clearing the list is not supported.

* @param[in,out] pChoiceField Acts as a handle to the native object of type \ref TPtxPdfForms_ChoiceField.


 * @return   Retrieved value.

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_ChoiceItemList* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceField_GetItems(TPtxPdfForms_ChoiceField* pChoiceField);

/**
 * @brief Get actual derived type of base type \ref TPtxPdfForms_ChoiceField.
 *
 * This function is invoked prior to downcasting to ascertain the derived object type.
 *
 * @param[in,out] pChoiceField Acts as a handle to a native object.
 *
 * @return The item of the enumeration \ref TPtxPdfForms_ChoiceFieldType that refers to the actual derived type. `0` in
 * case of an error.
 *
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 *       Get the error message with \ref Ptx_GetLastErrorMessage.
 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_ChoiceFieldType PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ChoiceField_GetType(TPtxPdfForms_ChoiceField* pChoiceField);
/******************************************************************************
 * ListBox
 *****************************************************************************/
/**
 * @brief Create a list box form field
The returned form field object is not yet used, but it is associated with the given target document.

* @param[in,out] pTargetDocument the output document with which the returned object is associated


 * @return   the newly created list box field

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument has already been closed

 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument is read-only

 * - \ref ePtx_Error_IllegalArgument the target document contains form fields that have been implicitly copied by a call
to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetFormFields "" was set to \ref ePtxPdfForms_FormFieldCopyStrategy_Copy ""

 * - \ref ePtx_Error_IllegalArgument the target document contains unsigned signatures that have been implicitly copied
by a call to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetUnsignedSignatures "" was set to \ref ePtxPdf_CopyStrategy_Copy "".


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_ListBox* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ListBox_Create(TPtxPdf_Document* pTargetDocument);

/**
 * @brief Allow multiple items to be selected
* @param[in,out] pListBox Acts as a handle to the native object of type \ref TPtxPdfForms_ListBox.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ListBox_GetAllowMultiSelect(TPtxPdfForms_ListBox* pListBox);
/**
 * @brief Allow multiple items to be selected
* @param[in,out] pListBox Acts as a handle to the native object of type \ref TPtxPdfForms_ListBox.

* @param[in] bAllowMultiSelect Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ListBox_SetAllowMultiSelect(TPtxPdfForms_ListBox* pListBox, BOOL bAllowMultiSelect);
/**
 * @brief The selected choice items

Adding to this list results in an error:
  - <b>IllegalState</b>
    - if the list has already been closed
    - if the choice field is marked a read-only
    - if this list is not empty and the list box field is not marked as multi-select
    - if the choice field has widgets
  - <b>UnsupportedOperation</b> if the document is read-only
  - <b>IllegalArgument</b>
    - if the given choice item is `NULL`
    - if the given choice item has already been closed
    - if the given choice item is already present in this list
    - if the given choice item does not belong to the list box field's choice items

Removing items or clearing the list results in an <b>IllegalState</b> error if the form field is marked as read-only, or
if it has widgets.

* @param[in,out] pListBox Acts as a handle to the native object of type \ref TPtxPdfForms_ListBox.


 * @return   Retrieved value.

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_ChoiceItemList* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ListBox_GetChosenItems(TPtxPdfForms_ListBox* pListBox);

/******************************************************************************
 * ComboBox
 *****************************************************************************/
/**
 * @brief Create a combo box form field
The returned form field object is not yet used, but it is associated with the given target document.

* @param[in,out] pTargetDocument the output document with which the returned object is associated


 * @return   the newly created combo box field

   `NULL` if there is an error.
 * @note An error occurred when `NULL` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument has already been closed

 * - \ref ePtx_Error_IllegalArgument if the <b>pTargetDocument</b> argument is read-only

 * - \ref ePtx_Error_IllegalArgument the target document contains form fields that have been implicitly copied by a call
to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetFormFields "" was set to \ref ePtxPdfForms_FormFieldCopyStrategy_Copy ""

 * - \ref ePtx_Error_IllegalArgument the target document contains unsigned signatures that have been implicitly copied
by a call to \ref PtxPdf_Page_Copy "" with an argument \ref PtxPdf_Page_Copy "pOptions" in which \ref
PtxPdf_PageCopyOptions_SetUnsignedSignatures "" was set to \ref ePtxPdf_CopyStrategy_Copy "".


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_ComboBox* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ComboBox_Create(TPtxPdf_Document* pTargetDocument);

/**
 * @brief Has an editable item
* @param[in,out] pComboBox Acts as a handle to the native object of type \ref TPtxPdfForms_ComboBox.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_ComboBox_GetCanEdit(TPtxPdfForms_ComboBox* pComboBox);
/**
 * @brief Has an editable item
* @param[in,out] pComboBox Acts as a handle to the native object of type \ref TPtxPdfForms_ComboBox.

* @param[in] bCanEdit Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL PtxPdfForms_ComboBox_SetCanEdit(TPtxPdfForms_ComboBox* pComboBox,
                                                                                   BOOL                   bCanEdit);
/**
 * @brief The selected combo box item
If this property is `NULL` then the \ref PtxPdfForms_ComboBox_GetEditableItemName "" is the selected value.
Setting this property automatically sets \ref PtxPdfForms_ComboBox_GetEditableItemName "" to `NULL`.

* @param[in,out] pComboBox Acts as a handle to the native object of type \ref TPtxPdfForms_ComboBox.


 * @return   Retrieved value.

  `NULL` if either an error occurred or the returned object is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `NULL` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalArgument if the provided choice item object does not belong to the combo box field

 * - \ref ePtx_Error_IllegalState if the form field is marked as read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_ChoiceItem* PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ComboBox_GetChosenItem(TPtxPdfForms_ComboBox* pComboBox);
/**
 * @brief The selected combo box item
If this property is `NULL` then the \ref PtxPdfForms_ComboBox_GetEditableItemName "" is the selected value.
Setting this property automatically sets \ref PtxPdfForms_ComboBox_GetEditableItemName "" to `NULL`.

* @param[in,out] pComboBox Acts as a handle to the native object of type \ref TPtxPdfForms_ComboBox.

* @param[in,out] pChosenItem Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalArgument if the provided choice item object does not belong to the combo box field

 * - \ref ePtx_Error_IllegalState if the form field is marked as read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ComboBox_SetChosenItem(TPtxPdfForms_ComboBox* pComboBox, TPtxPdfForms_ChoiceItem* pChosenItem);
/**
 * @brief The name of the editable item
This property is `NULL` if any of the combo box items is selected, i.e., if \ref PtxPdfForms_ComboBox_GetChosenItem ""
is not `NULL`. Setting this property automatically sets \ref PtxPdfForms_ComboBox_GetChosenItem "" to `NULL`.

* @param[in,out] pComboBox Acts as a handle to the native object of type \ref TPtxPdfForms_ComboBox.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has no editable item (\ref PtxPdfForms_ComboBox_GetCanEdit ""
property is \ref "FALSE")

 * - \ref ePtx_Error_IllegalState if the form field is marked as read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ComboBox_GetEditableItemNameA(TPtxPdfForms_ComboBox* pComboBox, char* pBuffer, size_t nBufferSize);
/**
 * @brief The name of the editable item
This property is `NULL` if any of the combo box items is selected, i.e., if \ref PtxPdfForms_ComboBox_GetChosenItem ""
is not `NULL`. Setting this property automatically sets \ref PtxPdfForms_ComboBox_GetChosenItem "" to `NULL`.

* @param[in,out] pComboBox Acts as a handle to the native object of type \ref TPtxPdfForms_ComboBox.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has no editable item (\ref PtxPdfForms_ComboBox_GetCanEdit ""
property is \ref "FALSE")

 * - \ref ePtx_Error_IllegalState if the form field is marked as read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ComboBox_GetEditableItemNameW(TPtxPdfForms_ComboBox* pComboBox, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief The name of the editable item
This property is `NULL` if any of the combo box items is selected, i.e., if \ref PtxPdfForms_ComboBox_GetChosenItem ""
is not `NULL`. Setting this property automatically sets \ref PtxPdfForms_ComboBox_GetChosenItem "" to `NULL`.

* @param[in,out] pComboBox Acts as a handle to the native object of type \ref TPtxPdfForms_ComboBox.

* @param[in] szEditableItemName Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has no editable item (\ref PtxPdfForms_ComboBox_GetCanEdit ""
property is \ref "FALSE")

 * - \ref ePtx_Error_IllegalState if the form field is marked as read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ComboBox_SetEditableItemNameA(TPtxPdfForms_ComboBox* pComboBox, const char* szEditableItemName);
/**
 * @brief The name of the editable item
This property is `NULL` if any of the combo box items is selected, i.e., if \ref PtxPdfForms_ComboBox_GetChosenItem ""
is not `NULL`. Setting this property automatically sets \ref PtxPdfForms_ComboBox_GetChosenItem "" to `NULL`.

* @param[in,out] pComboBox Acts as a handle to the native object of type \ref TPtxPdfForms_ComboBox.

* @param[in] szEditableItemName Set value.


 * @return    \ref TRUE if the operation is successful; \ref FALSE if there is an error.
 * @note An error occurred when \ref FALSE was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed

 * - \ref ePtx_Error_UnsupportedOperation if the document is read-only

 * - \ref ePtx_Error_IllegalState if the form field has no editable item (\ref PtxPdfForms_ComboBox_GetCanEdit ""
property is \ref "FALSE")

 * - \ref ePtx_Error_IllegalState if the form field is marked as read-only

 * - \ref ePtx_Error_IllegalState if the form field has widgets


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_ComboBox_SetEditableItemNameW(TPtxPdfForms_ComboBox* pComboBox, const WCHAR* szEditableItemName);

/******************************************************************************
 * SignatureField
 *****************************************************************************/
/**
 * @brief The visibility of the signature field
If \ref "TRUE", the signature field has a visual appearance on the page.

* @param[in,out] pSignatureField Acts as a handle to the native object of type \ref TPtxPdfForms_SignatureField.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_SignatureField_IsVisible(TPtxPdfForms_SignatureField* pSignatureField);

/**
 * @brief Get actual derived type of base type \ref TPtxPdfForms_SignatureField.
 *
 * This function is invoked prior to downcasting to ascertain the derived object type.
 *
 * @param[in,out] pSignatureField Acts as a handle to a native object.
 *
 * @return The item of the enumeration \ref TPtxPdfForms_SignatureFieldType that refers to the actual derived type. `0`
 * in case of an error.
 *
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 *       Get the error message with \ref Ptx_GetLastErrorMessage.
 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_SignatureFieldType PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_SignatureField_GetType(TPtxPdfForms_SignatureField* pSignatureField);
/******************************************************************************
 * SignedSignatureField
 *****************************************************************************/
/**
 * @brief The name of the person or authority that signed the document

This is the name of the signing certificate.

Note: The name of the signing certificate can only be extracted for signatures conforming to the PAdES or PDF standard
and not for proprietary/non-standard signature formats.
For non-standard signature formats the name as stored in the PDF is returned.

* @param[in,out] pSignedSignatureField Acts as a handle to the native object of type \ref
TPtxPdfForms_SignedSignatureField.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL PtxPdfForms_SignedSignatureField_GetNameA(
    TPtxPdfForms_SignedSignatureField* pSignedSignatureField, char* pBuffer, size_t nBufferSize);
/**
 * @brief The name of the person or authority that signed the document

This is the name of the signing certificate.

Note: The name of the signing certificate can only be extracted for signatures conforming to the PAdES or PDF standard
and not for proprietary/non-standard signature formats.
For non-standard signature formats the name as stored in the PDF is returned.

* @param[in,out] pSignedSignatureField Acts as a handle to the native object of type \ref
TPtxPdfForms_SignedSignatureField.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL PtxPdfForms_SignedSignatureField_GetNameW(
    TPtxPdfForms_SignedSignatureField* pSignedSignatureField, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief The date and time of signing

This represents the date and time of signing as specified in the signature.
For signatures that contain a time-stamp, the trusted time-stamp time is returned.

Note: The value can only be extracted for signatures conforming to the PAdES or PDF standard
and not for proprietary/non-standard signature formats.
For non-standard signature formats the date as stored in the PDF is returned.

* @param[in,out] pSignedSignatureField Acts as a handle to the native object of type \ref
TPtxPdfForms_SignedSignatureField.

* @param[out] pDate Retrieved value.


 * @return   \ref FALSE if either an error occurred or the `[out]` argument returns `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when \ref FALSE was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT BOOL PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_SignedSignatureField_GetDate(TPtxPdfForms_SignedSignatureField* pSignedSignatureField, TPtxSys_Date* pDate);

/**
 * @brief Get actual derived type of base type \ref TPtxPdfForms_SignedSignatureField.
 *
 * This function is invoked prior to downcasting to ascertain the derived object type.
 *
 * @param[in,out] pSignedSignatureField Acts as a handle to a native object.
 *
 * @return The item of the enumeration \ref TPtxPdfForms_SignedSignatureFieldType that refers to the actual derived
 * type. `0` in case of an error.
 *
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 *       Get the error message with \ref Ptx_GetLastErrorMessage.
 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_SignedSignatureFieldType PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_SignedSignatureField_GetType(TPtxPdfForms_SignedSignatureField* pSignedSignatureField);
/******************************************************************************
 * Signature
 *****************************************************************************/
/**
 * @brief The location of signing
The CPU host name or physical location of the signing.

* @param[in,out] pSignature Acts as a handle to the native object of type \ref TPtxPdfForms_Signature.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Signature_GetLocationA(TPtxPdfForms_Signature* pSignature, char* pBuffer, size_t nBufferSize);
/**
 * @brief The location of signing
The CPU host name or physical location of the signing.

* @param[in,out] pSignature Acts as a handle to the native object of type \ref TPtxPdfForms_Signature.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Signature_GetLocationW(TPtxPdfForms_Signature* pSignature, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief The reason for signing
* @param[in,out] pSignature Acts as a handle to the native object of type \ref TPtxPdfForms_Signature.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Signature_GetReasonA(TPtxPdfForms_Signature* pSignature, char* pBuffer, size_t nBufferSize);
/**
 * @brief The reason for signing
* @param[in,out] pSignature Acts as a handle to the native object of type \ref TPtxPdfForms_Signature.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Signature_GetReasonW(TPtxPdfForms_Signature* pSignature, WCHAR* pBuffer, size_t nBufferSize);
/**
 * @brief The contact information of the signer
Information provided by the signer to enable a recipient to contact
the signer to verify the signature; for example, a phone number.

* @param[in,out] pSignature Acts as a handle to the native object of type \ref TPtxPdfForms_Signature.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Signature_GetContactInfoA(TPtxPdfForms_Signature* pSignature, char* pBuffer, size_t nBufferSize);
/**
 * @brief The contact information of the signer
Information provided by the signer to enable a recipient to contact
the signer to verify the signature; for example, a phone number.

* @param[in,out] pSignature Acts as a handle to the native object of type \ref TPtxPdfForms_Signature.

* @param[out] pBuffer Retrieved value.
To determine the required buffer size, the function has to be called with `NULL`.
The return value of this function specifies the buffer size.

* @param[in] nBufferSize The buffer size of the retrieved string `pBuffer`.


 * @return   The amount of data written to the buffer `pBuffer`.
  `0` if either an error occurred or the returned buffer is actually `NULL`.
   To determine if an error has occurred, check the error code as described in the note section below.
 * @note An error occurred when `0` was returned <b>and</b> the error code returned by \ref Ptx_GetLastError is
different from \ref ePtx_Error_Success.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT size_t PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Signature_GetContactInfoW(TPtxPdfForms_Signature* pSignature, WCHAR* pBuffer, size_t nBufferSize);

/**
 * @brief Get actual derived type of base type \ref TPtxPdfForms_Signature.
 *
 * This function is invoked prior to downcasting to ascertain the derived object type.
 *
 * @param[in,out] pSignature Acts as a handle to a native object.
 *
 * @return The item of the enumeration \ref TPtxPdfForms_SignatureType that refers to the actual derived type. `0` in
 * case of an error.
 *
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 *       Get the error message with \ref Ptx_GetLastErrorMessage.
 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_SignatureType PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_Signature_GetType(TPtxPdfForms_Signature* pSignature);
/******************************************************************************
 * DocMdpSignature
 *****************************************************************************/
/**
 * @brief The access permissions granted for this document
Note that for encrypted PDF documents, the restrictions defined by this `DocMDPSignature` are in addition to the
document \ref PtxPdf_Document_GetPermissions "".

* @param[in,out] pDocMdpSignature Acts as a handle to the native object of type \ref TPtxPdfForms_DocMdpSignature.


 * @return   Retrieved value.

   May indicate an error in certain scenarios. For further information see the note section below.
 * @note An error occurred when `0` was returned. Retrieve specific error code by calling \ref Ptx_GetLastError.
 * Get the error message with \ref Ptx_GetLastErrorMessage.
 * Possible error codes:
 * - \ref ePtx_Error_IllegalState if the object has already been closed


 */
PDFTOOLS_TOOLBOX_EXPORT TPtxPdfForms_MdpPermissions PDFTOOLS_TOOLBOX_CALL
PtxPdfForms_DocMdpSignature_GetPermissions(TPtxPdfForms_DocMdpSignature* pDocMdpSignature);

#ifdef __cplusplus
}
#endif

#endif /* PDFTOOLS_TOOLBOX_PTXPDFFORMS_H__ */
